#!/bin/sh
set -e
-TESTDIR=$(readlink -f $(dirname $0))
-. $TESTDIR/framework
+TESTDIR="$(readlink -f "$(dirname "$0")")"
+. "$TESTDIR/framework"
setupenvironment
configarchitecture "i386"
buildaptarchive
+touch aptarchive/Packages
setupflataptarchive
testaptgetupdate() {
- aptget update 2>> testaptgetupdate.diff >> testaptgetupdate.diff || true
- sed -i -e '/^Fetched / d' -e 's#\[[0-9]* [kMGTPY]*B\]#\[\]#' testaptgetupdate.diff
+ rm -rf rootdir/var/lib/apt
+ aptget update >testaptgetupdate.diff 2>&1 || true
+ sed -i -e '/Ign /,+1d' -e '/Release/ d' -e 's#\[[0-9]* [kMGTPY]*B\]#\[\]#' testaptgetupdate.diff
GIVEN="$1"
shift
msgtest "Test for correctness of" "apt-get update with $*"
rm testaptgetupdate.diff
}
-touch aptarchive/en.bz2
+createemptyarchive() {
+ find aptarchive/ \( -name "Packages*" -o -name "en*" \) -type f -delete
+ touch aptarchive/Packages
+ echo -n "" | $COMPRESSOR_CMD > aptarchive/${1}.$COMPRESS
+ generatereleasefiles
+ signreleasefiles
+ rm -f aptarchive/Packages
+}
-testaptgetupdate "Ign file: Release.gpg
-Ign file:$(readlink -f aptarchive)/ Translation-en
-Get:1 file: Release []
-Reading package lists..." "empty file en.bz2 over file"
+createemptyfile() {
+ find aptarchive/ \( -name "Packages*" -o -name "en*" \) -type f -delete
+ touch aptarchive/Packages aptarchive/${1}.$COMPRESS
+ generatereleasefiles
+ signreleasefiles
+ rm -f aptarchive/Packages
+}
-rm aptarchive/en.bz2
-echo -n "" | bzip2 > aptarchive/en.bz2
+testoverfile() {
+ local APTARCHIVE="$(readlink -f ./aptarchive)"
+ forcecompressor "$1"
+
+ createemptyarchive 'Packages'
+ testaptgetupdate "Get:2 file:$APTARCHIVE Packages []
+Reading package lists..." "empty archive Packages.$COMPRESS over file"
+
+ createemptyfile 'Packages'
+ testaptgetupdate "Get:2 file:$APTARCHIVE Packages
+Err:2 file:$APTARCHIVE Packages
+ Empty files can't be valid archives
+Reading package lists...
+W: Failed to fetch ${COMPRESSOR}:${APTARCHIVE}/Packages.$COMPRESS Empty files can't be valid archives
+E: Some index files failed to download. They have been ignored, or old ones used instead." "empty file Packages.$COMPRESS over file"
+}
-testaptgetupdate "Ign file: Release.gpg
-Get:1 file: Release []
-Reading package lists..." "empty archive en.bz2 over file"
+testoverhttp() {
+ forcecompressor "$1"
+
+ createemptyarchive 'Packages'
+ testaptgetupdate "Get:2 http://localhost:${APTHTTPPORT} Packages []
+Reading package lists..." "empty archive Packages.$COMPRESS over http"
+
+ createemptyfile 'Packages'
+ #FIXME: we should response with a good error message instead
+ testaptgetupdate "Get:2 http://localhost:${APTHTTPPORT} Packages
+Err:2 http://localhost:${APTHTTPPORT} Packages
+ Empty files can't be valid archives
+Reading package lists...
+W: Failed to fetch ${COMPRESSOR}:$(readlink -f rootdir/var/lib/apt/lists/partial/localhost:${APTHTTPPORT}_Packages.${COMPRESS}) Empty files can't be valid archives
+E: Some index files failed to download. They have been ignored, or old ones used instead." "empty file Packages.$COMPRESS over http"
+}
-rm aptarchive/en.bz2
+for COMPRESSOR in 'gzip' 'bzip2' 'lzma' 'xz'; do testoverfile $COMPRESSOR; done
# do the same again with http instead of file
changetowebserver
-touch aptarchive/en.bz2
-
-testaptgetupdate "Ign http://localhost Release.gpg
-Get:1 http://localhost/ Translation-en
-Get:2 http://localhost Release []
-Ign http://localhost/ Translation-en
-Get:3 http://localhost Packages []
-Reading package lists..." "empty file en.bz2 over http"
-
-rm aptarchive/en.bz2
-echo -n "" | bzip2 > aptarchive/en.bz2
-
-testaptgetupdate "Ign http://localhost Release.gpg
-Get:1 http://localhost/ Translation-en []
-Get:2 http://localhost Release []
-Ign http://localhost Packages/DiffIndex
-Get:3 http://localhost Packages []
-Reading package lists..." "empty archive en.bz2 over http"
-
-rm aptarchive/en.bz2
-
-rm aptarchive/Packages
-touch aptarchive/Packages
-buildaptarchivefromfiles
-
-testaptgetupdate "Ign http://localhost Release.gpg
-Ign http://localhost/ Translation-en
-Get:1 http://localhost Release []
-Ign http://localhost Packages/DiffIndex
-Get:2 http://localhost Packages []
-Reading package lists..." "empty archive Packages over http"
-
-find aptarchive/ -name 'Packages*' -type f -delete
-touch aptarchive/Packages.bz2
-aptftparchive release aptarchive/ > aptarchive/Release
-
-#FIXME: we should response with a good error message instead
-testaptgetupdate "Ign http://localhost Release.gpg
-Ign http://localhost/ Translation-en
-Get:1 http://localhost Release []
-Ign http://localhost Packages/DiffIndex
-Get:2 http://localhost Packages
-Err http://localhost Packages
- Undetermined Error
-W: Failed to fetch http://localhost:8080/Packages.bz2 Undetermined Error
-
-E: Some index files failed to download, they have been ignored, or old ones used instead." "empty file Packages over http"
+for COMPRESSOR in 'gzip' 'bzip2' 'lzma' 'xz'; do testoverhttp $COMPRESSOR; done